using EvaPosSrvDTO;
using EvaPosSrvResp;
using GatewaySCO;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Linq;
using System.Xml.Serialization;
using static EvaPOS_API_FRAME.DTO.CancelActionDTO;

namespace EvaPOS_API_FRAME.Adaptadores
{
    /// <summary>
    /// Clase para cancelar acción en el datáfono
    /// </summary>
    public class AdaptadorCancelAction : IAdaptadorDTO
    {
        public string Referencia { get; set; } = "scsns:CancelAction";
        public string NombreElementoXMLDatos { get; set; } = "./CancelActionRequest";

        public DTOBase ObtieneDTO(int idSesion, TipoMensaje tipoMensaje, XmlElement docXml)
        {
            XmlNode? nodo = docXml.SelectSingleNode(NombreElementoXMLDatos);

            XmlSerializer serializer = new XmlSerializer(typeof(CancelActionRequest));
            CancelActionRequest dto;
            XmlNodeReader elemento = new XmlNodeReader(nodo);

            dto = (CancelActionRequest)serializer.Deserialize(elemento);

            if (nodo == null)
                throw new Exception($"Elemento '{NombreElementoXMLDatos}'.");
            dto.IdSesion = idSesion;
            dto.TipoMensaje = tipoMensaje;
            dto.RequestID = Util.LeeIntEnNodo(nodo, "./RequestID");

            return dto;
        }

        public IAdaptadorDTO CreaCopia()
        {
            return (AdaptadorCancelAction)this.MemberwiseClone();
        }
    }
}
